%define _libdir64 %{_prefix}/lib64

Name:           qrencode
Version:        4.0.1
Release:        1
Summary:        Generate QR 2D barcodes

Group:          Applications/Engineering
License:        LGPLv2+
URL:            http://megaui.net/fukuchi/works/qrencode/index.en.html
Source0:        http://megaui.net/fukuchi/works/%{name}/%{name}-%{version}.tar.bz2
Source1:        http://megaui.net/fukuchi/works/%{name}/%{name}-%{version}.tar.bz2.sha
Patch0:         %{name}-%{version}-aix.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  make, patch
BuildRequires:  libpng-devel >= 1.6.37-1
Requires:       libpng >= 1.6.37-1

%description
Qrencode is a utility software using libqrencode to encode string data in
a QR Code and save as a PNG image.


%package        devel
Summary:        QR Code encoding library - Development files
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       libpng-devel >= 1.6.37-1

%description    devel
The qrencode-devel package contains libraries and header files for developing
applications that use qrencode.


%prep
%setup -q
export PATH=/opt/freeware/bin:$PATH
%patch0
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CONFIG_SHELL=/usr/bin/ksh
export CONFIG_ENV_ARGS=/usr/bin/ksh

export CC="xlc_r"

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export png_CFLAGS="-I/opt/freeware/include"
export png_LIBS="-L/opt/freeware/lib -lpng"
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir}
gmake %{?_smp_mflags}

export png_CFLAGS=""
export png_LIBS=""
cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir}
gmake %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
gmake DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a ${RPM_BUILD_ROOT}%{_libdir64}/lib%{name}.so*

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%doc 32bit/ChangeLog 32bit/COPYING 32bit/NEWS 32bit/README 32bit/TODO
%{_bindir}/*
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
%{_mandir}/man1/*
/usr/bin/*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files devel
%{_includedir}/*
%{_libdir}/*.la
%{_libdir64}/*.la
%{_libdir}/pkgconfig/*.pc
%{_libdir64}/pkgconfig/*.pc
/usr/include/*
/usr/lib/*.la
/usr/lib64/*.la


%changelog
* Thu May 16 2019 Michael Perzl <michael@perzl.org> - 4.0.1-1
- updated to version 4.0.1

* Thu May 16 2019 Michael Perzl <michael@perzl.org> - 4.0.0-1
- updated to version 4.0.0

* Thu Jul 24 2014 Michael Perzl <michael@perzl.org> - 3.4.4-1
- updated to version 3.4.4

* Tue Aug 13 2013 Michael Perzl <michael@perzl.org> - 3.4.3-1
- updated to version 3.4.3

* Sun Mar 03 2013 Michael Perzl <michael@perzl.org> - 3.4.2-1
- updated to version 3.4.2

* Thu Oct 18 2012 Michael Perzl <michael@perzl.org> - 3.4.1-1
- updated to version 3.4.1

* Mon Oct 15 2012 Michael Perzl <michael@perzl.org> - 3.4.0-1
- updated to version 3.4.0

* Thu Apr 19 2012 Michael Perzl <michael@perzl.org> - 3.3.1-1
- updated to version 3.3.1

* Tue Apr 03 2012 Michael Perzl <michael@perzl.org> - 3.3.0-1
- updated to version 3.3.0

* Mon Apr 02 2012 Michael Perzl <michael@perzl.org> - 3.2.1-1
- first version for AIX V5.1 and higher
